//+------------------------------------------------------------------+
//|                                         Martengail-2Hands.mq4 |
//+------------------------------------------------------------------+

#property copyright "Maloma"
#include <stdlib.mqh>
#include <stderror.mqh>

  int Slippage = 3;
  int SleepOk = 2000;
  int SleepErr = 6000;

extern double Lot       = 1; //   .
extern int    Grid      = 19; //   .
       int    Limit     = 5; //     .
//       double LotSeq[8] = {1,1,3.1,3,5.9,11.3,25.3}; // For 19 AUDUSD   
//       double LotSeq[8] = {1,1,2.8,2.7,5.4,10.3,23.2}; // For 20 AUDUSD          
       double LotSeq[8] = {1,1,20,15,31,60,128}; //
       double GridSeq[8];
       double gk=15;

   double Spred;
   double SellWorkPrice;
   double BuyWorkPrice;
   double BuyStopPrice;
   double BuyStopProfit;
   double SellLimitPrice;
   double SellLimitProfit;
   double BuyLimitPrice;
   double BuyLimitProfit;
   double SellStopPrice;
   double SellStopProfit;
   int    StateOld, StateCur;
   int    Magic=120976;
   double CurrentPrice, OldPrice;
   int    Step;
   int    LastBuy, LastSell, ProfitOrder;
   int    BuyCnt, SellCnt, BuyStopCnt, BuyLimitCnt, SellStopCnt, SellLimitCnt;
   bool   DelAll, SetAll, AP;
   int    LastLock;
      
//+------------------------------------------------------------------+
//+       .       +
//+   4  ,  TRUE.   ,  FALSE +
//+------------------------------------------------------------------+
bool AllPresent() {

     BuyCnt = 0;
     SellCnt = 0;
     BuyStopCnt = 0;
     BuyLimitCnt = 0;
     SellStopCnt = 0;
     SellLimitCnt = 0;
     for (int cnt=OrdersTotal()-1;cnt>=0;cnt--)
         {
          OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
          if ((OrderSymbol() == Symbol()) && (OrderTicket() > LastLock))
             {
              Print ("Ticket=", OrderTicket(),"  OrderType=", OrderType(), "  OrderOpenPrice=", OrderOpenPrice(), "  OrderTakeProfit=", OrderTakeProfit()," Lots=",OrderLots());
              switch (OrderType())
                  {
                   case 0: BuyCnt++;
                           break;
                   case 1: SellCnt++;
                           break;
                   case 2: BuyLimitCnt++;
                           break;
                   case 3: SellLimitCnt++;
                           break;
                   case 4: BuyStopCnt++;
                           break;
                   case 5: SellStopCnt++;
                           break;
                  }
             }
         }
     Print ("Buy=",BuyCnt," Sell=",SellCnt," BuyStopCnt==",BuyStopCnt," BuyLimitCnt==",BuyLimitCnt," SellStopCnt==",SellStopCnt," SellLimitCnt==",SellLimitCnt," Bid=",Bid);
     if ((BuyStopCnt==0) || (BuyLimitCnt==0) || (SellStopCnt==0) || (SellLimitCnt==0)) {return(false);}
     else {return(true);}
} 

//+------------------------------------------------------------------+
//+       .  +
//+------------------------------------------------------------------+
int Initialization() { 

    Step = 1;
    StateCur = 0;
    StateOld=StateCur;
    Spred = Ask-Bid;
    RefreshRates();
    CurrentPrice = Bid;
    Print (Ask, " ", Bid+400*Point, " ", Ask-Grid*Point);
    Buy (Symbol(), LotSize(0), Ask, Ask-400*Point, Bid+Grid*Point, Magic, "");
    Sell (Symbol(), LotSize(0), Bid, Bid+400*Point, Ask-Grid*Point, Magic, "");
    GridSeq[0]=Grid;
    GridSeq[1]=Grid;
    GridSeq[2]=Grid;
    GridSeq[3]=Grid*2;
    GridSeq[4]=Grid*3;
    GridSeq[5]=Grid*4;
    GridSeq[6]=Grid*5;
    CalcAllPrice (CurrentPrice);
    SetAll = SetOrders (LotSize(1), LotSize(1), LotSize(1), LotSize(1));
    SearchLastSellBuy();
    LastLock=0;
}

//+---------------------+
//+  -     +
//+---------------------+
int PrSt(int what){

  Print ("What=",what," Time=",TimeToStr(CurTime(),TIME_DATE|TIME_SECONDS)," Ask=", Ask);

}
  
//+------------------------------------------------------------------------------+
//+           . +
//+------------------------------------------------------------------------------+  
double LotSize(int tStep) {

  for (int i=0;i<=Limit;i++)
    double aLots=LotSeq[i]+aLots;
  aLots++;
  Print ("aLots=", aLots);
//  double rez = NormalizeDouble(Lot*LotSeq[tStep],1);
  double rez = NormalizeDouble((AccountBalance()/aLots/1000)*LotSeq[tStep],1);
  if (rez < 0.1) {rez = 0.1;}
  Print ("rez lots=", rez);
  return(rez);
}

//+------------------------------------------------------------------+
//+         .  +
//+------------------------------------------------------------------+  
double CalcAllPrice(double SellPrice) {

/*   SellWorkPrice = NormalizeDouble(SellPrice,Digits);
   BuyWorkPrice = NormalizeDouble(SellWorkPrice+Spred,Digits);
   if (StateCur == 1)
     {
      BuyStopPrice = NormalizeDouble(BuyWorkPrice+GridSeq[Step]*Point,Digits);
      SellLimitPrice = NormalizeDouble(SellWorkPrice+GridSeq[Step]*Point,Digits);
      BuyLimitPrice = NormalizeDouble(BuyWorkPrice-GridSeq[Step-1]*Point,Digits);
      SellStopPrice = NormalizeDouble(SellWorkPrice-GridSeq[Step-1]*Point,Digits);
      BuyStopProfit = NormalizeDouble(BuyStopPrice-Spred+GridSeq[Step+1]*Point,Digits);
      SellLimitProfit = NormalizeDouble(SellLimitPrice+Spred-GridSeq[Step]*Point,Digits);
      BuyLimitProfit = NormalizeDouble(BuyLimitPrice-Spred+GridSeq[1]*Point,Digits);
      SellStopProfit = NormalizeDouble(SellStopPrice+Spred-GridSeq[1]*Point,Digits);
     }
   if (StateCur == -1)
     {
      BuyStopPrice = NormalizeDouble(BuyWorkPrice+GridSeq[Step-1]*Point,Digits);
      SellLimitPrice = NormalizeDouble(SellWorkPrice+GridSeq[Step-1]*Point,Digits);
      BuyLimitPrice = NormalizeDouble(BuyWorkPrice-GridSeq[Step]*Point,Digits);
      SellStopPrice = NormalizeDouble(SellWorkPrice-GridSeq[Step]*Point,Digits);
      BuyStopProfit = NormalizeDouble(BuyStopPrice-Spred+GridSeq[1]*Point,Digits);
      SellLimitProfit = NormalizeDouble(SellLimitPrice+Spred-GridSeq[1]*Point,Digits);
      BuyLimitProfit = NormalizeDouble(BuyLimitPrice-Spred+GridSeq[Step]*Point,Digits);
      SellStopProfit = NormalizeDouble(SellStopPrice+Spred-GridSeq[Step+1]*Point,Digits);
     }
   if (StateCur == 0)
     {
      BuyStopPrice = NormalizeDouble(BuyWorkPrice+GridSeq[1]*Point,Digits);
      SellLimitPrice = NormalizeDouble(SellWorkPrice+GridSeq[1]*Point,Digits);
      BuyLimitPrice = NormalizeDouble(BuyWorkPrice-GridSeq[1]*Point,Digits);
      SellStopPrice = NormalizeDouble(SellWorkPrice-GridSeq[1]*Point,Digits);
      BuyStopProfit = NormalizeDouble(BuyStopPrice-Spred+GridSeq[1]*Point,Digits);
      SellLimitProfit = NormalizeDouble(SellLimitPrice+Spred-GridSeq[1]*Point,Digits);
      BuyLimitProfit = NormalizeDouble(BuyLimitPrice-Spred+GridSeq[1]*Point,Digits);
      SellStopProfit = NormalizeDouble(SellStopPrice+Spred-GridSeq[1]*Point,Digits);
     }*/
   SellWorkPrice = SellPrice;
   BuyWorkPrice = SellWorkPrice+Spred;
   if (StateCur == 1)
     {
      BuyStopPrice = BuyWorkPrice+GridSeq[Step]*Point;
      SellLimitPrice = SellWorkPrice+GridSeq[Step]*Point;
      BuyLimitPrice = BuyWorkPrice-GridSeq[Step-1]*Point;
      SellStopPrice = SellWorkPrice-GridSeq[Step-1]*Point;
      BuyStopProfit = BuyStopPrice-Spred+GridSeq[Step+1]*Point;
      SellLimitProfit = SellLimitPrice+Spred-GridSeq[Step]*Point;
      BuyLimitProfit = BuyLimitPrice-Spred+GridSeq[1]*Point;
      SellStopProfit = SellStopPrice+Spred-GridSeq[1]*Point;
     }
   if (StateCur == -1)
     {
      BuyStopPrice = BuyWorkPrice+GridSeq[Step-1]*Point;
      SellLimitPrice = SellWorkPrice+GridSeq[Step-1]*Point;
      BuyLimitPrice = BuyWorkPrice-GridSeq[Step]*Point;
      SellStopPrice = SellWorkPrice-GridSeq[Step]*Point;
      BuyStopProfit = BuyStopPrice-Spred+GridSeq[1]*Point;
      SellLimitProfit = SellLimitPrice+Spred-GridSeq[1]*Point;
      BuyLimitProfit = BuyLimitPrice-Spred+GridSeq[Step]*Point;
      SellStopProfit = SellStopPrice+Spred-GridSeq[Step+1]*Point;
     }
   if (StateCur == 0)
     {
      BuyStopPrice = BuyWorkPrice+GridSeq[1]*Point;
      SellLimitPrice = SellWorkPrice+GridSeq[1]*Point;
      BuyLimitPrice = BuyWorkPrice-GridSeq[1]*Point;
      SellStopPrice = SellWorkPrice-GridSeq[1]*Point;
      BuyStopProfit = BuyStopPrice-Spred+GridSeq[1]*Point;
      SellLimitProfit = SellLimitPrice+Spred-GridSeq[1]*Point;
      BuyLimitProfit = BuyLimitPrice-Spred+GridSeq[1]*Point;
      SellStopProfit = SellStopPrice+Spred-GridSeq[1]*Point;
     }
   Print ("Spred=",Spred,"  SellWorkPrice=",SellWorkPrice,"  BuyWorkPrice=",BuyWorkPrice);
   Print ("BuyStopPrice=",BuyStopPrice,"  BuyStopProfit=",BuyStopProfit);
   Print ("SellLimitPrice=",SellLimitPrice,"  SellLimitProfit=",SellLimitProfit);
   Print ("BuyLimitPrice=",BuyLimitPrice,"  BuyLimitProfit=",BuyLimitProfit);
   Print ("SellStopPrice=",SellStopPrice,"  SellStopProfit=",SellStopProfit);
}

//+---------------------------------------------------------------------+
//+       Lx,  Lx   0 +
//+---------------------------------------------------------------------+  
bool SetOrders (double L1, double L2, double L3, double L4){
  bool rez;
  int temp;
  
  rez = true;
  if (L1 != 0) {
                temp = SetBuyStop(Symbol(), L1, BuyStopPrice, BuyStopPrice-400*Point, BuyStopProfit, Magic, "");
                if (temp != 1) {rez = false;}
               }
  if (L3 != 0) {
                temp = SetBuyLimit(Symbol(), L3, BuyLimitPrice, BuyLimitPrice-400*Point, BuyLimitProfit, Magic, "");
                if (temp != 1) {rez = false;}
               }
  if (L2 != 0) {
                temp = SetSellLimit(Symbol(), L2, SellLimitPrice, SellLimitPrice+400*Point, SellLimitProfit, Magic, "");
                if (temp != 1) {rez = false;}
               }
  if (L4 != 0) {
                temp = SetSellStop(Symbol(), L4, SellStopPrice, SellStopPrice+400*Point, SellStopProfit, Magic, "");
                if (temp != 1) {rez = false;}
               }
  return(rez);
}

//+----------------------------------------------------------------+
//+                          .                      +
//+----------------------------------------------------------------+  
bool First(){
 
  int ordcnt=0;
  for (int cnt=OrdersTotal()-1;cnt>=0;cnt--)
      {
       OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
       if ((OrderSymbol() == Symbol()) && (OrderTicket() > LastLock) && ((OrderType() == OP_BUY) || (OrderType() == OP_SELL))) {ordcnt++;}
      }
  if (ordcnt>0) {return(false);}
  else {return(true);}
}

//+------------------------------------------------------------------+
//+       BUY  SELL.       +
//+------------------------------------------------------------------+  
int SearchLastSellBuy(){
  
  LastBuy=0;
  LastSell=0;
  for (int cnt=OrdersTotal()-1;cnt>=0;cnt--)
      {
       OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
       if ((OrderSymbol() == Symbol()) && (OrderTicket() > LastLock) && (OrderType() == OP_BUY))
          {
           if (OrderTicket()>LastBuy) {LastBuy=OrderTicket();}
          }
       if ((OrderSymbol() == Symbol()) && (OrderTicket() > LastLock) && (OrderType() == OP_SELL))
          {
           if (OrderTicket()>LastSell) {LastSell=OrderTicket();}
          }   
      }
  return(0);
}

//+---------------------------------------------------------------------------+
//+    ,   .   ,  0.+
//+---------------------------------------------------------------------------+  
int TakeProfit(){
   
   ProfitOrder=0;
   for (int cnt=HistoryTotal()-1;cnt>=0;cnt--)
       {
        OrderSelect(cnt, SELECT_BY_POS, MODE_HISTORY);
        if ((OrderType() == OP_SELL) || (OrderType() == OP_BUY))
           if (OrderTicket() > ProfitOrder)
              if (OrderClosePrice() == OrderTakeProfit()) {ProfitOrder = OrderTicket();}
       }
   return(ProfitOrder);
}

//+---------------------------------------------------------------------------+
//+      .                           +
//+---------------------------------------------------------------------------+  
int LockSearch(){
   
  LastLock = 0;
  for (int cnt=OrdersTotal()-1;cnt>=0;cnt--)
      {
       OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
       if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == 1001001) && (OrderType() == OP_BUY))
          {
           if (OrderTicket()>LastLock) {LastLock=OrderTicket();}
          }
       if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == 1001001) && (OrderType() == OP_SELL))
          {
           if (OrderTicket()>LastLock) {LastLock=OrderTicket();}
          }   
      }
  return(0);
}

//+------------------------------------+
//+     +
//+------------------------------------+
bool DelNotNeed(){
  bool res, tmp;
  int max, cnt;

  Sleep(1000);
  tmp = true;
  for (cnt=OrdersTotal()-1;cnt>=0;cnt--)
      {
       RefreshRates();
       OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
       if ((OrderSymbol() == Symbol()) && (OrderTicket() > LastLock))
          {
           if (OrderType() > 1)
              {
               res = false;
               max = 100;
               while ((!res) && (max != 0)) 
                  {
                   res = OrderDelete(OrderTicket());
                   max--;
                   RefreshRates();
                  }
               if (!res) tmp = false;
              }
          }
      }
  return(tmp);
}

//+------------------------------------------------------------------------------------+
//+   ,          +
//+------------------------------------------------------------------------------------+
int MoveTP(bool Last){

  int cnt, err, ticket, max;
  bool res;
    
  if (StateCur == 1)
     {
      for (cnt=OrdersTotal()-1;cnt>=0;cnt--)
          {
           RefreshRates();
           OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
           if (OrderSymbol() == Symbol())
              {
               if (OrderType() == OP_SELL)
                  {
                   if ((Last)  && (OrderTicket() < LastLock))
                      {
                       res = false;
                       max = 100;
                       while ((!res) && (max != 0)) 
                          {
                           res = OrderModify(OrderTicket(), OrderOpenPrice(), 0, 0, 0, CLR_NONE);
                           res = GetLastError();
                           Sleep(1000);
                           max--;
                          }
                      }
                   else 
                      {
                       if ((OrderTicket() != LastSell) && (OrderTicket() > LastLock))
                          {
                           res = false;
                           max = 100;
                           while ((!res) && (max != 0))  
                              {
                               res = OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), BuyLimitPrice, 0, CLR_NONE);
                               res = GetLastError();
                               Sleep(1000);
                               max--;
                              }
                          }
                      }   
                  }
              }
          }
      return(0);
     }
  if (StateCur==-1)
     {
      for (cnt=OrdersTotal()-1;cnt>=0;cnt--)
          {
           RefreshRates();
           OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
           if (OrderSymbol() == Symbol())
              {
               if (OrderType() == OP_BUY)
                  {
                   if ((Last) && (OrderTicket() < LastLock))
                      {
                       res = false;
                       max = 100;
                       while ((!res) && (max != 0))  
                          {
                           res = OrderModify(OrderTicket(), OrderOpenPrice(), 0, 0, 0, CLR_NONE);
                           res = GetLastError();
                           Sleep(1000);
                           max--;
                          }
                      }
                   else 
                      {
                       if ((OrderTicket() != LastBuy) && (OrderTicket() > LastLock))
                          {
                           res = false;
                           max = 100;
                           while ((!res) && (max != 0))  
                              {
                               res = OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), SellLimitPrice, 0, CLR_NONE);
                               res = GetLastError();
                               Sleep(1000);
                               max--;
                              }
                          }
                      }
                  }
              }
          }
      return(0);
     }
}

//+++++++++++++++++++++++++++++++++++++++++++
//  ,   ... +
//+++++++++++++++++++++++++++++++++++++++++++
bool SetFlags(){

  Spred = MarketInfo(Symbol(), MODE_SPREAD);
  if (Digits == 4) {Spred = Spred / 10000;}
  else if (Digits == 2) {Spred = Spred / 100;}
  AP = AllPresent();
  if (BuyCnt > SellCnt) {Step = BuyCnt;} else {Step = SellCnt;}
  Print ("Step=",Step);
  Print (". Margin=",AccountMargin()," FreeMargin=",AccountFreeMargin()," Balance=",AccountBalance()," Equity=",AccountEquity());
}

//+---------------------------+
//+    +
//+---------------------------+
int start(){
  int tp;

  SetFlags();
  if (First()) {Initialization();}
  if (AP) {return (0);}
  tp = TakeProfit();
  PrSt(1); Print ("tp=", tp);
  if (tp == 0) {return(0);}
  SearchLastSellBuy();
  PrSt(2); Print ("LastSell=", LastSell, "  LastBuy=", LastBuy);
  LockSearch();
  PrSt(3); Print ("LastLock=", LastLock);
  OrderSelect(tp, SELECT_BY_TICKET);
  StateOld = StateCur;
  OldPrice = CurrentPrice;
  if (OrderType() == OP_BUY) StateCur = 1;
  else if (OrderType() == OP_SELL) StateCur = -1;
  CurrentPrice = OrderTakeProfit();
  PrSt(4); Print ("CurrentPrice=", CurrentPrice);
  
  DelAll = DelNotNeed();
  PrSt(5); Print ("DelNotNeed()");

  if (StateCur == 1) {CalcAllPrice(CurrentPrice);}
  if (StateCur == -1) {CalcAllPrice(CurrentPrice-Spred);}

  if (Step < (Limit + 1))
     {
      MoveTP(false);
      if (StateCur == 1) {SetAll = SetOrders (LotSize(1), LotSize(Step), LotSize(1), LotSize(1));}
      if (StateCur == -1) {SetAll = SetOrders (LotSize(1), LotSize(1), LotSize(Step), LotSize(1));}
     }
  if (Step == (Limit + 1))
     {
      MoveTP(false);
      if (StateCur == 1) {
                          SetBuyStop(Symbol(), LotSize(Step), BuyStopPrice, 0, 0, 1001001, "LOCK");
                          SetAll = SetOrders (LotSize(1), LotSize(1), LotSize(1), LotSize(1));
                         }
      if (StateCur == -1) {
                           SetSellStop(Symbol(), LotSize(Step), SellStopPrice, 0, 0, 1001001, "LOCK");
                           SetAll = SetOrders (LotSize(1), LotSize(1), LotSize(1), LotSize(1));
                          }
     }
  if (Step > (Limit+1))
     { 
      Step=1;
      MoveTP(true);
      if (StateCur == 1) {SetAll = SetOrders (LotSize(1), LotSize(Step), LotSize(1), LotSize(1));}
      if (StateCur == -1) {SetAll = SetOrders (LotSize(1), LotSize(1), LotSize(Step), LotSize(1));}
     }
  PrSt(7);
  Print (". Margin=",AccountMargin()," FreeMargin=",AccountFreeMargin()," Balance=",AccountBalance()," Equity=",AccountEquity());
  return (0);
}


string err = "";

int OrderStrToType(string type) {
  if (type == "buy") return(OP_BUY);
  if (type == "sell") return(OP_SELL);
  if (type == "buy limit") return(OP_BUYLIMIT);
  if (type == "sell limit") return(OP_SELLLIMIT);
  if (type == "buy stop") return (OP_BUYSTOP);
  if (type == "sell stop") return (OP_SELLSTOP);
  
  return(-1);
}

string OrderTypeToStr(int type) {
  switch (type) {
    case OP_BUY: 
      return("buy"); 

    case OP_SELL: 
      return("sell"); 
      
    case OP_BUYLIMIT: 
      return("buy limit");
      
    case OP_SELLLIMIT: 
      return("sell limit");
            
    case OP_BUYSTOP: 
      return("buy stop");

    case OP_SELLSTOP: 
      return("sell stop");
      
    default: 
      return("unk_type");
  }
}

bool MarketOrder(int type) {
  return (type == OP_BUY || type == OP_SELL);
}

bool PendingOrder(int type) {
  return (type == OP_BUYSTOP || type == OP_BUYLIMIT || 
    type == OP_SELLSTOP || type == OP_SELLLIMIT);
}

//*************************************************************************************************

int Buy(string symbol, double lot, double price, double sl, double tp, int magic, string comment="") {
  double bid = MarketInfo(symbol, MODE_BID);
  double ask = MarketInfo(symbol, MODE_ASK);
  double point = MarketInfo(symbol, MODE_POINT);
  double lev = MarketInfo(symbol, MODE_STOPLEVEL)*point;
  int dig = MarketInfo(symbol, MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
  
  if (sl > 0 && sl >= price-lev) {
    err = "Buy: Invalid SL. " + 
      "Price= " + DoubleToStr(price, dig) + ". " +
      "SL= " + DoubleToStr(sl, dig) + ".";
    return(-1);
  }

  if (tp > 0 && tp <= price+lev) {
    err = "Buy: Invalid TP. " +
      "Price= " + DoubleToStr(price, dig) + ". " +
      "TP= " + DoubleToStr(tp, dig) + ".";
    return(-1);
  }

  int res = -1;
  while (res < 0) {
    RefreshRates();
    res = OrderSend(symbol, OP_BUY, lot, price, Slippage, sl, tp, comment, magic);
   	if (res < 0) {
   	  int code = GetLastError();
   	  switch (code) {
   	    case ERR_INVALID_PRICE: break;
   	    case ERR_INVALID_STOPS: break;
   	    case ERR_INVALID_TRADE_VOLUME: break;
   	    case ERR_NOT_ENOUGH_MONEY: break;
   	  }
   	  Print("Error opening BUY order: ", ErrorDescription(code));
        Sleep(SleepErr);
		}
	}
	
	Sleep(SleepOk);
	return(res);
}

int Sell(string symbol, double lot, double price, double sl, double tp, int magic, string comment="") {
  double bid = MarketInfo(symbol, MODE_BID);
  double ask = MarketInfo(symbol, MODE_ASK);
  double point = MarketInfo(symbol, MODE_POINT);
  double lev = MarketInfo(symbol, MODE_STOPLEVEL)*point;
  int dig = MarketInfo(symbol, MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);

  if (sl > 0 && sl <= price+lev) {
    err = "Sell: Invalid SL. " +
      "Price= " + DoubleToStr(price, dig) + ". " +
      "SL= " + DoubleToStr(sl, dig) + ".";
    return(-1);
  }

  if (tp > 0 && tp >= price-lev) {
    err = "Sell: Invalid TP. " +
      "Price= " + DoubleToStr(price, dig) + ". " +
      "TP= " + DoubleToStr(tp, dig) + ".";
    return(-1);
  }

  int res = -1;
  while (res < 0) {
    RefreshRates();
    res = OrderSend(symbol, OP_SELL, lot, price, Slippage, sl, tp, comment, magic);
   	if (res < 0) {
   	  int code = GetLastError();
   	  switch (code) {
   	    case ERR_INVALID_PRICE: break;
   	    case ERR_INVALID_STOPS: break;
   	    case ERR_INVALID_TRADE_VOLUME: break;
   	    case ERR_NOT_ENOUGH_MONEY: break;
   	  }
   	     	
      Print("Error opening SELL order: ", ErrorDescription(code));
      Sleep(SleepErr);
    }
  }
	
  Sleep(SleepOk);
  return(res);
}

int SetBuyStop(string symbol, double lot, double price, double sl, double tp, int magic, string comment="") {
  double bid = MarketInfo(symbol, MODE_BID);
  double ask = MarketInfo(symbol, MODE_ASK);
  double point = MarketInfo(symbol, MODE_POINT);
  double lev = MarketInfo(symbol, MODE_STOPLEVEL)*point;
  int dig = MarketInfo(symbol, MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
  
  if (price <= ask+lev) {
    err = "SetBuyStop: Invalid Price. " + 
      "Price= " + DoubleToStr(price, dig) + ". " +
      "Ask= " + DoubleToStr(ask, dig) + ".";
    return(-1);
  }

  if (sl > 0 && sl >= price-lev) {
    err = "SetBuyStop: Invalid SL. " +
      "Price= " + DoubleToStr(price, dig) + ". " +
      "SL= " + DoubleToStr(sl, dig) + ".";
    return(-1);
  }

  if (tp > 0 && tp <= price+lev) {
    err = "SetBuyStop: Invalid TP. " +
      "Price= " + DoubleToStr(price, dig) + ". " +
      "TP= " + DoubleToStr(tp, dig) + ".";
    return(-1);
  }

  int res = -1;
  while (res < 0) {
    RefreshRates();
    res = OrderSend(symbol, OP_BUYSTOP, lot, price, Slippage, sl, tp, comment, magic);
   	if (res < 0) {
   	  int code = GetLastError();
   	  switch (code) {
   	    case ERR_INVALID_PRICE: break;
   	    case ERR_INVALID_STOPS: break;
   	    case ERR_INVALID_TRADE_VOLUME: break;
   	  }
   	
   	  Print("Error setting BUYSTOP order: ", ErrorDescription(code));
			Sleep(SleepErr);
		}
	}
	
	Sleep(SleepOk);
	return(res);
}

int SetSellStop(string symbol, double lot, double price, double sl, double tp, int magic, string comment="") {
  double bid = MarketInfo(symbol, MODE_BID);
  double ask = MarketInfo(symbol, MODE_ASK);
  double point = MarketInfo(symbol, MODE_POINT);
  double lev = MarketInfo(symbol, MODE_STOPLEVEL)*point;
  int dig = MarketInfo(symbol, MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
Print(price, " ", sl, " ", tp);  
  if (price >= bid-lev) {
    err = "SetSellStop: Invalid Price. " +
      "Price= " + DoubleToStr(price, dig) + ". " +
      "Bid= " + DoubleToStr(bid, dig) + ".";
    return(-1);
  }

  if (sl > 0 && sl <= price+lev) {
    err = "SetSellStop: Invalid SL. " +
      "Price= " + DoubleToStr(price, dig) + ". " +
      "SL= " + DoubleToStr(sl, dig) + ".";
    return(-1);
  }

  if (tp > 0 && tp >= price-lev) {
    err = "SetSellStop: Invalid TP. " +
      "Price= " + DoubleToStr(price, dig) + ". " +
      "TP= " + DoubleToStr(tp, dig) + ".";
    return(-1);
  }
Print(err);  
  int res = -1;
  while (res < 0) {
    RefreshRates();
    res = OrderSend(symbol, OP_SELLSTOP, lot, price, Slippage, sl, tp, comment, magic);
   	if (res < 0) {
   	  int code = GetLastError();
   	  switch (code) {
   	    case ERR_INVALID_PRICE: break;
   	    case ERR_INVALID_STOPS: break;
   	    case ERR_INVALID_TRADE_VOLUME: break;
   	  }
   	
   	  Print("Error setting SELLSTOP order: ", ErrorDescription(code));
			Sleep(SleepErr);
		}
	}
	
	Sleep(SleepOk);
	return(res);
}

int SetBuyLimit(string symbol, double lot, double price, double sl, double tp, int magic, string comment="") {
  double bid = MarketInfo(symbol, MODE_BID);
  double ask = MarketInfo(symbol, MODE_ASK);
  double point = MarketInfo(symbol, MODE_POINT);
  double lev = MarketInfo(symbol, MODE_STOPLEVEL)*point;
  int dig = MarketInfo(symbol, MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);

  if (price >= ask-lev) {
    err = "SetBuyLimit: Invalid Price. " +
      "Price= " + DoubleToStr(price, dig) + ". " +
      "Ask= " + DoubleToStr(ask, dig) + ".";
    return(-1);
  }

  if (sl > 0 && sl >= price-lev) {
    err = "SetBuyLimit: Invalid SL. " +
      "Price= " + DoubleToStr(price, dig) + ". " +
      "SL= " + DoubleToStr(sl, dig) + ".";
    return(-1);
  }

  if (tp > 0 && tp <= price+lev) {
    err = "SetBuyLimit: Invalid TP. " +
      "Price= " + DoubleToStr(price, dig) + ". " +
      "TP= " + DoubleToStr(tp, dig) + ".";
    return(-1);
  }

  int res = -1;
  while (res < 0) {
    RefreshRates();
    res = OrderSend(symbol, OP_BUYLIMIT, lot, price, Slippage, sl, tp, comment, magic);
    if (res < 0) {
      int code = GetLastError();
   	  switch (code) {
   	    case ERR_INVALID_PRICE: break;
   	    case ERR_INVALID_STOPS: break;
   	    case ERR_INVALID_TRADE_VOLUME: break;
   	  }
    
      Print("Error setting BUYLIMIT order: ", ErrorDescription(code));
      Sleep(SleepErr);
    }
  }
	
  Sleep(SleepOk);
  return(res);
}

int SetSellLimit(string symbol, double lot, double price, double sl, double tp, int magic, string comment="") {
  double bid = MarketInfo(symbol, MODE_BID);
  double ask = MarketInfo(symbol, MODE_ASK);
  double point = MarketInfo(symbol, MODE_POINT);
  double lev = MarketInfo(symbol, MODE_STOPLEVEL)*point;
  int dig = MarketInfo(symbol, MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);

  if (price <= bid+lev) {
    err = "SetSellLimit: Invalid Price. " +
      "Price= " + DoubleToStr(price, dig) + ". " +
      "Bid= " + DoubleToStr(bid, dig) + ".";
    return(-1);
  }

  if (sl > 0 && sl <= price+lev) {
    err = "SetSellLimit: Invalid SL. " +
      "Price= " + DoubleToStr(price, dig) + ". " +
      "SL= " + DoubleToStr(sl, dig) + ".";
    return(-1);
  }

  if (tp > 0 && tp >= price-lev) {
    err = "SetSellLimit: Invalid TP. " +
      "Price= " + DoubleToStr(price, dig) + ". " +
      "TP= " + DoubleToStr(tp, dig) + ".";
    return(-1);
  }

  int res = -1;
  while (res < 0) {
    RefreshRates();
    res = OrderSend(symbol, OP_SELLLIMIT, lot, price, Slippage, sl, tp, comment, magic);
    if (res < 0) {
      int code = GetLastError();
   	  switch (code) {
   	    case ERR_INVALID_PRICE: break;
   	    case ERR_INVALID_STOPS: break;
   	    case ERR_INVALID_TRADE_VOLUME: break;
   	  }
    
      Print("Error setting SELLLIMIT order: ", ErrorDescription(code));
      Sleep(SleepErr);
    }
  }
	
  Sleep(SleepOk);
  return(res);
}

int ModifyOrder(int ticket, double price, double sl, double tp) {
  OrderSelect(ticket, SELECT_BY_TICKET);
  
  double bid = MarketInfo(OrderSymbol(), MODE_BID);
  double ask = MarketInfo(OrderSymbol(), MODE_ASK);
  double point = MarketInfo(OrderSymbol(), MODE_POINT);
  double lev = MarketInfo(OrderSymbol(), MODE_STOPLEVEL)*point;
  int dig = MarketInfo(OrderSymbol(), MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);

  double price0 = NormalizeDouble(OrderOpenPrice(), dig);
  double sl0 = NormalizeDouble(OrderStopLoss(), dig);
  double tp0 = NormalizeDouble(OrderTakeProfit(), dig);
  
  if (price == price0 && sl == sl0 && tp == tp0) return(0);
      
  int type = OrderType();
  if (type == OP_BUY) {
    if (sl > 0 && sl >= bid-lev) {
      err = "ModifyOrder: Invalid SL. " +
        "Type= " + OrderTypeToStr(type) + ". " +
        "Bid= " + DoubleToStr(bid, dig) + ". " +
        "SL= " + DoubleToStr(sl, dig) + ". ";
      return(-1);
    }

    if (tp > 0 && tp <= bid+lev) {
      err = "ModifyOrder: Invalid TP. " +
        "Type= " + OrderTypeToStr(type) + ". " +
        "Bid= " + DoubleToStr(bid, dig) + ". " +
        "TP= " + DoubleToStr(tp, dig) + ". ";
      return(-1);
    }
  }
  
  if (type == OP_BUYLIMIT) {
    if (price >= ask-lev) {
      err = "ModifyOrder: Invalid Price. " +
        "Type= " + OrderTypeToStr(type) + ". " +
        "Price= " + DoubleToStr(price, dig) + ". " +
        "Ask= " + DoubleToStr(ask, dig) + ". ";
      return(-1);
    }
    
    if (sl > 0 && sl >= price-lev) {
      err = "ModifyOrder: Invalid SL. " +
        "Type= " + OrderTypeToStr(type) + ". " +
        "Price= " + DoubleToStr(price, dig) + ". " +
        "SL= " + DoubleToStr(sl, dig) + ". ";
      return(-1);
    }

    if (tp > 0 && tp <= price+lev) {
      err = "ModifyOrder: Invalid TP. " +
        "Type= " + OrderTypeToStr(type) + ". " +
        "Price= " + DoubleToStr(price, dig) + ". " +
        "TP= " + DoubleToStr(tp, dig) + ". ";
      return(-1);
    }
  }

  if (type == OP_BUYSTOP) {
    if (price <= ask+lev) {
      err = "ModifyOrder: Invalid Price. " +
        "Type= " + OrderTypeToStr(type) + ". " +
        "Price= " + DoubleToStr(price, dig) + ". " +
        "Ask= " + DoubleToStr(ask, dig) + ". ";
      return(-1);
    }
    
    if (sl > 0 && sl >= price-lev) {
      err = "ModifyOrder: Invalid SL. " +
        "Type= " + OrderTypeToStr(type) + ". " +
        "Price= " + DoubleToStr(price, dig) + ". " +
        "SL= " + DoubleToStr(sl, dig) + ". ";
      return(-1);
    }

    if (tp > 0 && tp <= price+lev) {
      err = "ModifyOrder: Invalid TP. " +
        "Type= " + OrderTypeToStr(type) + ". " +
        "Price= " + DoubleToStr(price, dig) + ". " +
        "TP= " + DoubleToStr(tp, dig) + ". ";
      return(-1);
    }
  }
  
  if (type == OP_SELL) {
    if (sl > 0 && sl <= ask+lev) {
      err = "ModifyOrder: Invalid SL. " +
        "Type= " + OrderTypeToStr(type) + ". " +
        "Ask= " + DoubleToStr(ask, dig) + ". " +
        "SL= " + DoubleToStr(sl, dig) + ". ";
      return(-1);
    }

    if (tp > 0 && tp >= ask-lev) {
      err = "ModifyOrder: Invalid TP. " +
        "Type= " + OrderTypeToStr(type) + ". " +
        "Ask= " + DoubleToStr(ask, dig) + ". " +
        "TP= " + DoubleToStr(tp, dig) + ". ";
      return(-1);
    }  
  }
  
  if (type == OP_SELLLIMIT) {
    if (price <= bid+lev) {
      err = "ModifyOrder: Invalid Price. " +
        "Type= " + OrderTypeToStr(type) + ". " +
        "Price= " + DoubleToStr(price, dig) + ". " +
        "Bid= " + DoubleToStr(bid, dig) + ". ";
      return(-1);
    }
    
    if (sl > 0 && sl <= price+lev) {
      err = "ModifyOrder: Invalid SL. " +
        "Type= " + OrderTypeToStr(type) + ". " +
        "Price= " + DoubleToStr(price, dig) + ". " +
        "SL= " + DoubleToStr(sl, dig) + ". ";
      return(-1);
    }

    if (tp > 0 && tp >= price-lev) {
      err = "ModifyOrder: Invalid TP. " +
        "Type= " + OrderTypeToStr(type) + ". " +
        "Price= " + DoubleToStr(price, dig) + ". " +
        "TP= " + DoubleToStr(tp, dig) + ". ";
      return(-1);
    }
  }

  if (type == OP_SELLSTOP) {
    if (price >= bid-lev) {
      err = "ModifyOrder: Invalid Price. " +
        "Type= " + OrderTypeToStr(type) + ". " +
        "Price= " + DoubleToStr(price, dig) + ". " +
        "Bid= " + DoubleToStr(bid, dig) + ". ";
      return(-1);
    }
    
    if (sl > 0 && sl <= price+lev) {
      err = "ModifyOrder: Invalid SL. " +
        "Type= " + OrderTypeToStr(type) + ". " +
        "Price= " + DoubleToStr(price, dig) + ". " +
        "SL= " + DoubleToStr(sl, dig) + ". ";
      return(-1);
    }

    if (tp > 0 && tp >= price-lev) {
      err = "ModifyOrder: Invalid TP. " +
        "Type= " + OrderTypeToStr(type) + ". " +
        "Price= " + DoubleToStr(price, dig) + ". " +
        "TP= " + DoubleToStr(tp, dig) + ". ";
      return(-1);
    }    
  }

  bool res = false;
  while (!res) {
    RefreshRates();
    res = OrderModify(ticket, price, sl, tp, 0);
    if (!res) {
      int code = GetLastError();
   	  switch (code) {
   	    case ERR_INVALID_PRICE: break;
   	    case ERR_INVALID_STOPS: break;
   	  }
    
      Print("OrderModify failed: ", ErrorDescription(code));
      Sleep(SleepErr);
    }
  }

  Sleep(SleepOk);
  return(0);
}

int CloseOrder(int ticket, double lot, double price) {
  int dig = MarketInfo(OrderSymbol(), MODE_DIGITS);
  price = NormalizeDouble(price, dig);

  bool res = false;
  while (!res) {
    RefreshRates();
    res = OrderClose(ticket, lot, price, Slippage);
    if (!res) {
      int code = GetLastError();
   	  switch (code) {
   	    case ERR_INVALID_PRICE: break;
   	    case ERR_INVALID_TRADE_VOLUME: break;
   	  }
    
      Print("CloseOrder failed: ", ErrorDescription(code));
      Sleep(SleepErr);
    }
  }

  Sleep(SleepOk);
  return(0);
}

int DeleteOrder(int ticket) {
  bool res = false;
  while (!res) {
    RefreshRates();
    res = OrderDelete(ticket);
    if (!res) {
      Print("DeleteOrder failed: ", ErrorDescription(GetLastError()));
		  Sleep(SleepErr);
    }
  }

  Sleep(SleepOk);
  return(0);
}